/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription, StringFilterTypes } from './general';

export const StringFilters: Record<StringFilterTypes, GeneralDescription<StringFilterTypes>> = {
  [StringFilterTypes.EQUAL]: {
    key: 'stringFilterEqual',
    name: 'Equal',
    type: StringFilterTypes.EQUAL,
    description: 'Equal to another value',
    numInputs: 1,
    inputs: [
      { name: '1', type: 'string', default: '' },
      { name: '2', type: 'string', default: '' },
    ],
    output: { name: StringFilterTypes.EQUAL, type: 'bool' },
    logic: [StringFilterTypes.EQUAL, '@1', '@2'],
  },
  [StringFilterTypes.NOT_EQUAL]: {
    key: 'stringFilterNotEqual',
    name: 'Not Equal',
    type: StringFilterTypes.NOT_EQUAL,
    description: 'Not equal to another value',
    numInputs: 1,
    inputs: [
      { name: '1', type: 'string', default: '' },
      { name: '2', type: 'string', default: '' },
    ],
    output: { name: StringFilterTypes.NOT_EQUAL, type: 'bool' },
    logic: [StringFilterTypes.NOT_EQUAL, '@1', '@2'],
  },
  // [StringFilterTypes.IN]: {
  //   key: 'stringFilterContains',
  //   name: 'Contains',
  //   type: StringFilterTypes.IN,
  //   description: 'Contains another value',
  //   numInputs: 1,
  //   inputs: [
  //     { name: '1', type: 'string', default: '' },
  //     { name: '2', type: 'string', default: '' },
  //   ],
  //   output: { name: StringFilterTypes.IN, type: 'bool' },
  //   logic: [StringFilterTypes.IN, '@1', '@2'],
  // },
  [StringFilterTypes.LIKE]: {
    key: 'stringFilterLike',
    name: 'Like',
    type: StringFilterTypes.LIKE,
    description: 'Like another value',
    numInputs: 1,
    inputs: [
      { name: '1', type: 'string', default: '' },
      { name: '2', type: 'string', default: '' },
    ],
    output: { name: StringFilterTypes.LIKE, type: 'bool' },
    logic: [StringFilterTypes.LIKE, '@1', '@2'],
  },
};

/** All available functions in the function bar. */
export const StringFilterArray: Array<GeneralDescription<StringFilterTypes>> = Object.values(StringFilters);
